;This program draws a horizontal line with character 'star' with lenght defined by variable 'n' (task 3 solution)
;-demonstrates:
;- decision making using JLE instruction
;- use of INT 21 to write character
;- note the layout preference of original author
;
;Original author: Ian Harries <ih@doc.ic.ac.uk>

		.MODEL SMALL	; Data and code fit in one 64K segment
		.STACK       	; allocate a stack
		.CODE			; start of code segment

;       INT 21 - WRITE CHARACTER TO STANDARD OUTPUT
;       AH = 02h
;       DL = character to write
;       Return: AL = last character output

star    equ '*'

        ;***** setup DS register *****
        mov ax,@data	;point DS to data segment
        mov ds,ax
	
        mov cl,0        ; count = 0

l0:     inc cl          ; count = count + 1
        cmp cl,[n]      ; if count > n
        jg done         ; then done

        mov ah,02h      ; else, write character to standard output
        mov dl,star     ; character to write
        int 21h         ; print("*")

		jmp l0          ; repeat

done:   mov ax,4c00h	; function: exit to dos with errorlevel 0
        int 21h

        .data

n       db 7            ; variable n

;TASK:
;1. TRY WITH DIFFERENT VALUES OF N
;2. WHAT HAPPENS WHEN n=0? ANS: The program still print one '*'.  This is because the program start by printing the first start, before checking 'n'.
;3. SAVE THE PROGRAM AS HLINE1A.ASM AND SOLVE THE ABOVE PROBLEM.  ANS: Start with CL=0, and print '*' after every increment until CL GREATER than 'n'.
;4. EDIT THE PROGRAM, SAVE AS VLINE.ASM, SO THAT IT DRAWS A VERTICAL LINE INSTEAD

        end